; $Id: app_defines.h bdupeyron.tech@gmail.com(Antichambre)
;
; Specific Defines and variables of MIOS Application
;
; ==========================================================================
;
;  Copyright 1998-2006 Thorsten Klose (tk@midibox.org)
;  Licensed for personal non-commercial use only.
;  All other rights reserved.
; 
; ==========================================================================

	;; free memory for user applications:	
	;; 0x010-0x37f

;; ==========================================================================
;;  TIA register set
;; ==========================================================================                                                            
TIA_BASE          EQU	0x100           ; address space of TIA chip (used: 0x00-0x05)

TIA_AUDC0      EQU TIA_BASE+0x00	;; control. for voice 1 (Aud0)
TIA_AUDC1      EQU TIA_BASE+0x01	;; control. for voice 2 (Aud1)
TIA_AUDF0      EQU TIA_BASE+0x02	;; freq. for voice 1 (Aud0)
TIA_AUDF1      EQU TIA_BASE+0x03	;; freq. for voice 2 (Aud1)
TIA_AUDV0      EQU TIA_BASE+0x04	;; vol. for voice 1 (Aud0)
TIA_AUDV1      EQU TIA_BASE+0x05	;; vol. for voice 2 (Aud1)

TIA_BASE_END		EQU	0x10f

;; ==========================================================================

TIA_SHADOW_BASE		EQU	0x110		; shadow addresses, necessary to determine changes (used: 0x00-0x05)

	;; (TIA_SHADOW_BASE + 0x00) to (TIA_SHADOW_BASE + 0x05) allocated by shadow registers

TIA_SHADOW_END		EQU	0x11f

